Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 510422 - dev-libs/glib timezone assumptions do not work with sys-libs/timezone-data-2014c+
Summary: dev-libs/glib timezone assumptions do not work with sys-libs/timezone-data-20...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] GNOME (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Gentoo Linux Gnome Desktop Team
URL: https://bugzilla.gnome.org/show_bug.c...
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2014-05-15 20:11 UTC by Harris Landgarten
Modified: 2014-05-28 15:14 UTC (History)
20 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Harris Landgarten 2014-05-15 20:11:17 UTC
after upgrade to timezone-data-2014c gnome-3 clock showed 3:04 PM when it was 4:00p. timedatactl from systemd shows the right time and timezone. downgrading to 2014b fixes the gnome clock immediately.
Comment 1 Jeroen Roovers gentoo-dev 2014-05-15 22:33:22 UTC
1) Please post your `emerge --info' output in a comment.
2) I'm afraid to ask, but did you restart GNOME after the upgrade?
Comment 2 Harris Landgarten 2014-05-15 22:41:44 UTC
no restart possible yet. But downgrade restored the time and timedatectl was happy with either. The gnome clock is supposed to get settings from systemd and dbus. What could cause time to be off by such an odd amount?

Harris
Comment 3 Harris Landgarten 2014-05-15 22:49:00 UTC
just tried it again and time instantly changed from 6:44p to 5:48p

I restarted gnome-shell but no change.

I then installed timezone-data-2014b and time changed back to correct instantly.

Seems something is wrong. BTW I am in America/New_York time zone.
Comment 4 Jeroen Roovers gentoo-dev 2014-05-15 22:49:49 UTC
What timezone do you use and how did you set it up?
Comment 5 Jeroen Roovers gentoo-dev 2014-05-15 22:50:08 UTC
(In reply to Jeroen Roovers from comment #1)
> 1) Please post your `emerge --info' output in a comment.

And?
Comment 6 Mark R. Pariente 2014-05-16 04:44:53 UTC
Same problem, timezone-data-2014c results in the time being displayed as one hour earlier than it should be in GNOME 3.12 - downgrading to 2014b instantly fixes the issue.

# timedatectl
      Local time: Thu 2014-05-15 21:43:17 PDT
  Universal time: Fri 2014-05-16 04:43:17 UTC
        RTC time: Thu 2014-05-15 21:43:17
       Time zone: America/Los_Angeles (PDT, -0700)
     NTP enabled: yes
NTP synchronized: yes
 RTC in local TZ: yes
      DST active: yes
 Last DST change: DST began at
                  Sun 2014-03-09 01:59:59 PST
                  Sun 2014-03-09 03:00:00 PDT
 Next DST change: DST ends (the clock jumps one hour backwards) at
                  Sun 2014-11-02 01:59:59 PDT
                  Sun 2014-11-02 01:00:00 PST

With timezone-data-2014c GNOME 3.12 shell clock shows 20:43 whereas 'date' or 'timedatectl' shows 21:43. The timezone is also set correctly to LA in gnome-control-center Date/Time settings..

emerge --info:

Portage 2.2.10 (default/linux/amd64/13.0/desktop/gnome, gcc-4.8.2, glibc-2.19, 3.14.4-gentoo x86_64)
=================================================================
System uname: Linux-3.14.4-gentoo-x86_64-Intel-R-_Core-TM-_i7_CPU_950_@_3.07GHz-with-gentoo-2.2
KiB Mem:    12281068 total,    166212 free
KiB Swap:   16787888 total,  16784220 free
Timestamp of tree: Fri, 16 May 2014 02:15:01 +0000
ld GNU gold (GNU Binutils 2.24) 1.11
distcc 3.1 x86_64-pc-linux-gnu [disabled]
app-shells/bash:          4.2_p47
dev-java/java-config:     2.2.0
dev-lang/python:          2.7.6-r1, 3.3.5, 3.4.0
dev-util/cmake:           2.8.12.2-r1
dev-util/pkgconfig:       0.28-r1
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.12.4
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.10.3, 1.11.6, 1.14.1
sys-devel/binutils:       2.24-r2
sys-devel/gcc:            4.7.3-r1, 4.8.2
sys-devel/gcc-config:     1.8
sys-devel/libtool:        2.4.2-r1
sys-devel/make:           4.0-r1
sys-kernel/linux-headers: 3.14 (virtual/os-headers)
sys-libs/glibc:           2.19
Repositories: gentoo vmware mrpdaemon steam-overlay sunrise r3pek megacoffee Mark-s-local-portage-overlay
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O3 -pipe -fomit-frame-pointer"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt /usr/share/maven-bin-3.1/conf"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=native -O3 -pipe -fomit-frame-pointer"
DISTDIR="/usr/portage/distfiles"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs buildpkg config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirror.usu.edu/mirrors/gentoo/ http://gentoo.llarian.net/ http://gentoo.mirrors.easynews.com/linux/gentoo/ http://gentoo.gossamerhost.com http://gentoo.mirrors.hoobly.com/"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j9 -l9"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/var/lib/layman/vmware /var/lib/layman/mrpdaemon /var/lib/layman/steam /var/lib/layman/sunrise /var/lib/layman/r3pek /var/lib/layman/megacoffee /usr/local/portage"
SYNC="rsync://rsync27.us.gentoo.org/gentoo-portage"
USE="X a52 aac acl acpi alsa amd64 avahi bash-completion berkdb bluray branding bzip2 cairo cdda cdr cli clutter colord cracklib crypt cscope cups cxx dbus dri dts dv dvd dvdr eds emboss encode evo exif faac fam ffmpeg firefox flac fortran gdbm gif git glade gnome gnome-keyring gnome-online-accounts gphoto2 gpm gstreamer gtk iconv introspection ipv6 jabber jpeg lcms libnotify libsecret mad mmx mmxext mng modules mp3 mp4 mpeg msn multilib nautilus ncurses networkmanager nls nptl ogg opengl openmp pam pango pcre pdf png policykit ppds pulseaudio python qt3support qt4 readline rtmp sdl session socialweb spell sse sse2 sse3 sse4_1 sse4_2 ssl ssse3 startup-notification svg systemd tcpd theora threads tiff tracker truetype udev udisks unicode upower usb v4l vala vdpau vim-syntax vorbis vpx wxwidgets x264 xcb xml xv xvid xvmc zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias access_compat" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="*" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_3" RUBY_TARGETS="ruby19 ruby20" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 7 Mark R. Pariente 2014-05-16 04:45:23 UTC
I also reproduced the problem in my GNOME 3.10 virtual machine so it's not specific to 3.12.
Comment 8 Patrick Nicolas 2014-05-16 05:39:21 UTC
I have had the same issue : 2014c changes the time immediately.

The new time appears to be solar mean time of the city selected in gnome date and time configuration panel.
Instead of displaying CEST for Paris, it will display LMT with a 9 minute offset from UTC. Time will also be different for several european city which are normally in CEST timezone.
Comment 9 Marcin Sochoń (soki) 2014-05-16 05:48:22 UTC
I have this problem also in cinnamon 2.2.
Comment 10 Jura 2014-05-16 08:30:59 UTC
I have this problem in gnome-3.12
Comment 11 Martin Wegner 2014-05-16 12:04:08 UTC
I can confirm the observations made in comment #8, time is shown as LMT (Local Mean Time) instead of CEST for me here (UTC+02). The rest of the system is not affected, timedatectl, hwclock and date each show the correct time and timezone settings:

$ timedatectl
      Local time: Fri 2014-05-16 13:54:54 CEST
  Universal time: Fri 2014-05-16 11:54:54 UTC
        RTC time: Fri 2014-05-16 11:54:54
       Time zone: Europe/Berlin (CEST, +0200)
     NTP enabled: yes
NTP synchronized: yes
 RTC in local TZ: no
      DST active: yes
 Last DST change: DST began at
                  Sun 2014-03-30 01:59:59 CET
                  Sun 2014-03-30 03:00:00 CEST
 Next DST change: DST ends (the clock jumps one hour backwards) at
                  Sun 2014-10-26 02:59:59 CEST
                  Sun 2014-10-26 02:00:00 CET

For me the gnome clock is about 1 hour and 7 minutes behind the actual clock.

Downgrading to timezone-data-2014b immediately fixes this, when the ebuild updates /etc/localtime:

[...]
 * Updating /etc/localtime with /usr/share/zoneinfo/Europe/Berlin

Then, the clock displays correct CEST time again. Updating to 2014c shows the "wrong" time again immediately after the ebuild executed the above line.

The whole gnome desktop 3.10 is affected, i. e. gnome-shell, date & time settings, ... while e. g. KDE seems not to be affected as e. g. kde-base/systemsettings still displays correct time with timezone-data-2014c.

$ emerge --info
Portage 2.2.10 (default/linux/amd64/13.0/desktop/gnome, gcc-4.8.2, glibc-2.19, 3.14.4-gentoo-wotan x86_64)
=================================================================
System uname: Linux-3.14.4-gentoo-wotan-x86_64-Intel-R-_Core-TM-_i7-3520M_CPU_@_2.90GHz-with-gentoo-2.2
KiB Mem:     7921232 total,    514560 free
KiB Swap:    8388604 total,   8388604 free
Timestamp of tree: Fri, 16 May 2014 10:45:01 +0000
ld GNU ld (GNU Binutils) 2.24
ccache version 3.1.9 [disabled]
app-shells/bash:          4.2_p47
dev-java/java-config:     2.2.0
dev-lang/python:          2.7.6-r1, 3.2.5-r4, 3.3.5, 3.4.0
dev-util/ccache:          3.1.9-r3
dev-util/cmake:           2.8.12.2-r1
dev-util/pkgconfig:       0.28-r1
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.12.4
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.11.6, 1.13.4, 1.14.1
sys-devel/binutils:       2.24-r2
sys-devel/gcc:            4.8.2
sys-devel/gcc-config:     1.8
sys-devel/libtool:        2.4.2-r1
sys-devel/make:           4.0-r1
sys-kernel/linux-headers: 3.14 (virtual/os-headers)
sys-libs/glibc:           2.19
Repositories: gentoo x-portage
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=native -O2 -pipe"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--jobs=1 --load-average=5"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs candy clean-logs config-protect-if-modified distlocks ebuild-locks fakeroot fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms splitdebug strict unknown-features-warn unmerge-backup unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="        ftp://sunsite.informatik.rwth-aachen.de/pub/Linux/gentoo        ftp://mirror.netcologne.de/gentoo/       ftp://sunsite.informatik.rwth-aachen.de/pub/Linux/gentoo"
LANG="C"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j4 -l4"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage"
SYNC="rsync://rsync.de.gentoo.org/gentoo-portage"
USE="X a52 aac acpi alsa amd64 amr avahi berkdb bluetooth branding bzip2 cairo cdda cdr cli colord cracklib crypt cryptsetup cups cxx dbus dirac divx dri dts dvb dvd dvdr emboss encode exif faac faad fam fat ffmpeg firefox flac fuse gdbm gif gnome gnome-keyring gnome-online-accounts gnutls gstreamer gtk gtk3 iconv idn inotify introspection ipv6 jpeg lame lastfm lcms libnotify libsecret mad mmx mmxext mng modules mp3 mp4 mpeg multilib nautilus ncurses networkmanager nls nptl offensive ogg opengl openmp pam pango pcre pdf png policykit ppds pulseaudio readline realmedia samba schroedinger sdl sendto session smartcard socialweb spell sse sse2 ssl startup-notification svg syslog systemd tcpd telepathy theora tiff tracker truetype udev udisks unicode upower usb v4l v4l2 vim-syntax vorbis vpx webm wmp wxwidgets x264 xcb xinerama xml xv xvid zeitgeist zeroconf zlib zsh-completion" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CURL_SSL="gnutls" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="evdev keyboard mouse synaptics" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en de" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_3" QEMU_SOFTMMU_TARGETS="x86_64 i386" RUBY_TARGETS="ruby19 ruby20" USERLAND="GNU" VIDEO_CARDS="intel" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, USE_PYTHON
Comment 12 Mikko Koskelin 2014-05-16 22:50:00 UTC
I can confirm this too. Downgrading fixes the problem instantly.
Comment 13 Paolo 2014-05-17 11:34:43 UTC
downgrading works for me too :)
Comment 14 Michael Hampicke 2014-05-17 14:47:13 UTC
I can confirm this bug too, downgrading to sys-libs/timezone-data-2014b solves this issue for me.

With sys-libs/timezone-data-2014c time in Gnome lags behind the system time for 65 minutes.
Comment 15 Pacho Ramos gentoo-dev 2014-05-18 08:59:32 UTC
*** Bug 510628 has been marked as a duplicate of this bug. ***
Comment 16 Adrian Bassett 2014-05-18 10:14:10 UTC
The upgrade to timezone-data-2014c played havoc with dates in gnucash.  Downgrading to -2014b fixed the problem.
Comment 17 Alexandre Rostovtsev (RETIRED) gentoo-dev 2014-05-18 14:17:06 UTC
With 2014c, glib's g_date_time_new_now_local() returns the wrong result.
However, libc's time() / localtime() returns the correct time for my timezone.

This suggests that the bug is in glib, not timezone-data.
Comment 18 Alexandre Rostovtsev (RETIRED) gentoo-dev 2014-05-19 15:15:06 UTC
Because this is a major issue (it can lead to people being late for the train) and affects everything based on glib, I've temporarily masked =timezone-data-2014c until we have a patch for glib to support the new timezone format.

+  19 May 2014; Alexandre Rostovtsev <tetromino@gentoo.org> package.mask:
+  Temporarily mask timezone-data-2014c because dev-libs/glib can't parse the
+  new timezone format, leading to wrong timestamps everywhere.
Comment 19 Mart Raudsepp gentoo-dev 2014-05-19 15:25:55 UTC
Perhaps in the meantime we could have a timezone-data-2013c-r1 that could use previous tzcode (or whatever zic is in), with the new tzdata, so Egypt DST is better?
http://mm.icann.org/pipermail/tz-announce/2014-May/000020.html and URL reference of this bug
Comment 20 SpanKY gentoo-dev 2014-05-19 16:34:44 UTC
(In reply to Mart Raudsepp from comment #19)

is that really critical ?  i don't think it is ...
Comment 21 Nikos Chantziaras 2014-05-19 18:38:57 UTC
(In reply to SpanKY from comment #20)
> (In reply to Mart Raudsepp from comment #19)
> 
> is that really critical ?  i don't think it is ...

Depends on how critical the appointment is that you are going to miss due to the wrong clock.
Comment 22 Marien Zwart (RETIRED) gentoo-dev 2014-05-20 10:24:07 UTC
I haven't tested this, but it should be possible to use the new tzdata with previous tzcode. Debian seems to do something like that.

IIUC the impact is:

With new tzcode most people using their clock through glib (like Gnome users) will have a clock that's off (likely an hour off if they're currently supposed to have DST, a few minutes if not).

With old tzdata everyone in Egypt will have their clock an hour off (missing the DST that was very recently introduced there).

If I had to guess I'd expect Gentoo Gnome users currently in DST to outnumber Egyptian Gentoo users, but I haven't tried to come up with actual estimates. So masking timezone-data for now makes sense to me.

And just to nitpick: it's not strictly speaking a format change (the package.mask entry calls it that), more of an edge case in the existing format. The sad thing is the change is meant to render the very code in glib it's breaking unused...
Comment 23 SpanKY gentoo-dev 2014-05-20 22:03:12 UTC
(In reply to Nikos Chantziaras from comment #21)

considering we've never done emergency stabilizations in the past and people haven't complained, i don't think it's a problem.  it's also highly unlikely that this is unique to Gentoo.  if the Egyptian gov't actually cared about their clocks being sane, they wouldn't have made such changes with 7 days of notice.
Comment 24 Dirkjan Ochtman gentoo-dev 2014-05-28 15:14:17 UTC
I've just committed timezone-data-2014d which works around the glib issues.